package org.iphsoft.simon1.ui;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;

import com.R;

import org.iphsoft.simon1.AndroidPortAdditions;
import org.iphsoft.simon1.GameMenuActivity;
import org.iphsoft.simon1.util.BackgroundMusicPlayer;
import org.iphsoft.simon1.util.BitmapUtils;
import org.iphsoft.simon1.util.ImmersiveModeHelper;

public class IHNMListChooser extends Activity {

	public static final String EXTRA_TITLE = "org.iphsoft.simon1.ui.DialogActivity.EXTRA_TITLE";
	public static final String EXTRA_POSITIVE_BUTTON = "org.iphsoft.simon1.ui.DialogActivity.EXTRA_POSITIVE_BUTTON";
	public static final String EXTRA_NEGATIVE_BUTTON = "org.iphsoft.simon1.ui.DialogActivity.EXTRA_NEGATIVE_BUTTON";
	public static final String EXTRA_LIST_ITEMS = "org.iphsoft.simon1.ui.DialogActivity.EXTRA_LIST_ITEMS";

	public static final String EXTRA_RESULT = "org.iphsoft.simon1.ui.DialogActivity.EXTRA_RESULT";

	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);

		mImmersiveModeHelper = new ImmersiveModeHelper(this);

		setContentView(R.layout.ihnm_list_chooser);

		Intent intent = getIntent();
		String titleTxt = intent.getStringExtra(EXTRA_TITLE);
		String positiveButtonTxt = intent.getStringExtra(EXTRA_POSITIVE_BUTTON);
		String negativeButtonTxt = intent.getStringExtra(EXTRA_NEGATIVE_BUTTON);
		CharSequence[] listItems = intent.getCharSequenceArrayExtra(EXTRA_LIST_ITEMS);

		TextView txtTitle = (TextView) findViewById(R.id.txtTitle);
		TextView btnPositive = (TextView) findViewById(R.id.btnPositive);
		TextView btnNegative = (TextView) findViewById(R.id.btnNegative);
		final IHNMListView lvItems = (IHNMListView) findViewById(R.id.lvItems);

		txtTitle.setText(titleTxt);
		btnPositive.setText(positiveButtonTxt);
		btnNegative.setText(negativeButtonTxt);
		lvItems.setEntries(listItems, null);
		lvItems.setItemChecked(0, true);

		btnPositive.setOnClickListener(new OnClickListener()
		{

			@Override
			public void onClick(View v)
			{
				setResult(RESULT_OK, new Intent().putExtra(EXTRA_RESULT, lvItems.getCheckedItemPosition()));
				finish();
				ActivityAnimationUtil.makeActivityNullTransition(IHNMListChooser.this);
			}
		});

		btnNegative.setOnClickListener(new OnClickListener()
		{

			@Override
			public void onClick(View v)
			{
				setResult(RESULT_CANCELED);
				finish();
				ActivityAnimationUtil.makeActivityNullTransition(IHNMListChooser.this);
			}
		});

		BitmapUtils.setScaledBackground(this, findViewById(R.id.bg_frame), R.drawable.bg_settings2);
	}

	@Override
	protected void onResume()
	{
		super.onResume();

		mImmersiveModeHelper.supportFullScreenImmersiveMode();
	}



	@Override
	public void onBackPressed()
	{
		super.onBackPressed();

		ActivityAnimationUtil.makeActivityNullTransition(IHNMListChooser.this);
	}
	
	@Override
	protected void onStart()
	{
		super.onStart();

		//StatisticsManager.getStatistics().reportActivityStart(this);

		if (AndroidPortAdditions.HAS_BACKGROUND_MUSIC
				&& getIntent().getBooleanExtra(GameMenuActivity.EXTRA_MID_GAME, true) == false)
		{
			BackgroundMusicPlayer.addBackgroundMusicActivity();
		}
	}

	@Override
	protected void onStop()
	{
		super.onStop();

		//StatisticsManager.getStatistics().reportActivityStop(this);

		if (AndroidPortAdditions.HAS_BACKGROUND_MUSIC
				&& getIntent().getBooleanExtra(GameMenuActivity.EXTRA_MID_GAME, true) == false)
		{
			BackgroundMusicPlayer.removeBackgroundMusicActivity();
		}
	}

	private ImmersiveModeHelper mImmersiveModeHelper;
}