package org.iphsoft.simon1.ui;

import android.content.Context;
import android.graphics.Typeface;
import android.util.AttributeSet;

import com.R;

public class T7GButton extends MagicTextView {

	public T7GButton(Context context)
	{
		super(context);
	}

	public T7GButton(Context context, AttributeSet attrs, int defStyle)
	{
		super(context, attrs, defStyle);
	}

	public T7GButton(Context context, AttributeSet attrs)
	{
		super(context, attrs);
	}

	@Override
	public void init(AttributeSet attrs)
	{
		super.init(attrs);
		
		if (!isInEditMode())
		{
			// Set font
			Typeface tf = Typeface.createFromAsset(getContext().getAssets(), "arabian.ttf");
			setTypeface(tf);
		}

		// Set text size
		float density = getResources().getDisplayMetrics().density;
		setTextSize(getResources().getDimensionPixelSize(R.dimen.button_text_size) / density);

		setTextColor(getResources().getColorStateList(R.drawable.button_text_color));

		updateShadows();

		setLines(1);
		setMaxLines(1);
		
	}
	
	@Override
	protected void drawableStateChanged()
	{
		super.drawableStateChanged();
		
		updateShadows();
		invalidate();
	}
	
	private void updateShadows()
	{
		// Get the relevant drawable state
		boolean statePressed = false, stateEnabled = false;
		int[] states = getDrawableState();
		for (int state : states)
		{
			if (state == android.R.attr.state_enabled)
				stateEnabled = true;
			else if (state == android.R.attr.state_pressed)
				statePressed = true;
		}
		
		clearInnerShadows();
		
		// Update shadows according to drawable state
		if (!stateEnabled)
		{
			// Disabled
			setShadowLayer(1.0f, 0f, 2.0f, getResources().getColor(R.color.button_disabled_shadow));
			addInnerShadow(1.0f, 0f, 4.0f, getResources().getColor(R.color.button_disabled_shadow_inner));
		}
		else if (statePressed)
		{
			// Pressed
			setShadowLayer(2.0f, 0f, 6.0f, getResources().getColor(R.color.button_pressed_shadow));
			addInnerShadow(3.0f, 0f, 4.0f, getResources().getColor(R.color.button_pressed_shadow_inner));
		}
		else
		{
			// Normal
			setShadowLayer(1.0f, 0f, 2.0f, getResources().getColor(R.color.button_shadow));
			addInnerShadow(1.0f, 0f, 4.0f, getResources().getColor(R.color.button_shadow_inner));
		}
	}
}
