
package org.iphsoft.simon1.util;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

import android.content.Context;
import android.os.Environment;
import android.os.StatFs;

public class FileUtils {

    public static long getBytesAvailableOnExternalStorage() {
        StatFs stat = new StatFs(Environment.getExternalStorageDirectory().getPath());
		long bytes;
		if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.JELLY_BEAN_MR2){
			bytes = (long)stat.getAvailableBlocksLong() * (long)stat.getBlockSizeLong();
		} else {
			bytes = (long)stat.getAvailableBlocks() * (long)stat.getBlockSize();
		}
        
        MyLog.d("FileUtils: getBytesAvailableOnExternalStorage: bytes available " + bytes);
        
        return bytes;
    }

	public static void copyAssetToExternalStorage(Context ctx, String asset, String name)
	{
		if (name == null)
		{
			name = asset;
		}
		
		// If file exists, return
		if (new File(Environment.getExternalStorageDirectory() + File.separator + name).exists())
		{
			return;
		}
	
		InputStream is;
		try
		{
			is = ctx.getAssets().open(asset);
		} catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
			return;
		}
	
		copyInputStreamToExternalStorage(is, name);
	}

	public static void copyRawFileExternalStorage(Context ctx, int fileResource, String name)
	{
		// If file exists, return
		if (new File(Environment.getExternalStorageDirectory() + File.separator + name).exists())
		{
			return;
		}
	
		InputStream is = ctx.getResources().openRawResource(fileResource);
	
		copyInputStreamToExternalStorage(is, name);
	}

	private static void copyInputStreamToExternalStorage(InputStream is, String name)
	{
		try
		{
			FileOutputStream os = new FileOutputStream(Environment.getExternalStorageDirectory()
					.getPath() + File.separator + name);
	
			byte[] buf = new byte[1024 * 64];
			int res;
			while ((res = is.read(buf)) != -1)
			{
				os.write(buf, 0, res);
			}
	
			os.flush();
			os.close();
			is.close();
	
		} catch (FileNotFoundException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
